import java.util.Scanner;

import Units.Player;
import World.Map;
import World.Location;
import World.Mine;
import World.WarpZone;
import World.Loot;

import Items.*;

import java.util.ArrayList;

public class GameExample {
   
    public static void main(String[] args) {
        Scanner myScanner = new Scanner(System.in);
        final Map map = new Map(30, 10);
        Player player = new Player(map, 2, 2);
              

        
        map.createOpenMap();
        
        map.setLocation(5, 5, new Mine(3));
        map.setLocation(20, 5, new Mine(10));
        map.setLocation(10, 8, new Mine(3)); 
        
        Map house = new Map(9, 9);
        house.createOpenMap();
        
        map.setLocation(8, 0, new WarpZone('O', house, 4, 7));
        house.setLocation(4, 8, new WarpZone('O', map, 8, 1));
        
        house.setLocation(4, 1, new Loot(new HealthPotion("Health Potion", 5, 3)));
        house.setLocation(5, 1, new Loot(new Potion('T', "Recall", 10) {
            
            @Override
            public void activatePotionEffect(Player player) {
                player.warpTo(map, 8, 1);
            }
            
        }));
        
        while (!player.isDead()) {
            System.out.println("Current health: " + player.getHealth());
            player.printInMap();
            
            System.out.println("Where would you like to go?");
            System.out.println("1. Up");
            System.out.println("2. Left");
            System.out.println("3. Down");
            System.out.println("4. Right");
            System.out.println("5. Show inventory");
            
            switch(myScanner.nextInt()) {
                case 1:
                    player.movePlayer(0, -1);
                    break;
                case 2:
                    player.movePlayer(-1, 0);
                    break;
                case 3:
                    player.movePlayer(0, 1);
                    break;
                case 4:
                    player.movePlayer(1, 0);
                    break;
                case 5:
                    showInventory(player, myScanner);
                    break;
                default:
                    System.out.println("Invalid option");
            }
        }
    }
    
    
    private static void showInventory(Player player, Scanner scanner) {
        while (true) {
            System.out.println("Inventory");
            ArrayList<Item> items = player.getItems();
            
            for (int i = 0; i < items.size(); i++) {
                Item item = items.get(i);
                
                System.out.println((i + 1) + ". " + (item != null ? item.getName() : "Empty"));
            }
            System.out.println((items.size() + 1) + ". Go back to the map");
            
            System.out.println("What would you like to do?");
            int option = scanner.nextInt();
            
            if (option >= 1 && option <= items.size()) {
                if (items.get(option - 1) != null && items.get(option - 1).useItem(player)) {
                    items.remove(option - 1);
                }
            }else if(option == items.size() + 1) {
                break;
            }else{
                System.out.println("Invalid option");
            }
        }       
    }
    
}