import java.util.ArrayList;
    
public class InventoryExample {
    public static void main(String[] args) {
        HatStand roomForAHat = new HatStand();
        Player steve = new Player("Steve");
        Chest smallChest = new MagicChest(10);
        
        Item nonHat = new Item("Definitely-Not-A-Hat", 5, 3); 
        Item boots = new Armor("Boots of Magic", 250, 3, 3, 20);
        Item helmet = new Armor("Epic helmet", 1000, 0, 5, 10);
        Item cap = new Armor("Weird cap", 10, 0, 1, 4);
        
        addItemToInventory(roomForAHat, nonHat);
        addItemToInventory(roomForAHat, boots);
        addItemToInventory(roomForAHat, helmet);
        addItemToInventory(roomForAHat, cap);
        
        addItemToInventory(steve, boots);
        addItemToInventory(steve, cap);
        
        addItemToInventory(smallChest, nonHat);
        
        
        printItems(getLootAfterDamage(steve, 100));
        printItems(getLootAfterDamage(steve, 100));
    }
    
    private static void printItems(ArrayList<Item> items) {
        if (items.size() == 0) {
            System.out.println("No loot for you");
        }else{
            System.out.println("Loot");
            for (Item item : items) {
                System.out.println(item.getName() + " x" + item.getAmount());
            }
        }
    }
    
    private static ArrayList<Item> getLootAfterDamage(IDamageable unit, int damage) {
        ArrayList<Item> items = new ArrayList<Item>();
        
        unit.takeDamage(damage);
        if (unit.isDead() && unit instanceof IInventory) {
            IInventory inv = (IInventory)unit;
            for (int i = 0; i < inv.getInventorySize(); i++) {
                if (inv.getContent(i) != null) {
                    items.add(inv.getContent(i));
                }
            }
        }
        
        return items;
    }
    
    
    
    private static void addItemToInventory(IInventory inv, Item item) {
        for (int i = 0; i < inv.getInventorySize(); i++) {
            if (inv.getContent(i) == null && inv.setContent(i, item)) {
                System.out.println(item.getName() + " added at position " + i);
                return;
            }
        }
        System.out.println(item.getName() + " can't be added to this inventory");
    }
        
}