package Items;

import Units.Player;

public abstract class Potion extends Item {
 
    private int maxUses;
    private int usesLeft;
    
    public Potion(char symbol, String name, int uses) {
        super(symbol, name);
        usesLeft = maxUses = uses;
    }
    
    @Override
    public String getName() {
        return super.getName() + " [" + usesLeft + "/" + maxUses + "]";
    }
    
    //return true to consume
    @Override
    public boolean useItem(Player player) {
       activatePotionEffect(player);
        
        usesLeft--;
        
        return usesLeft == 0;
    }    
    
    public abstract void activatePotionEffect(Player player);
    
}