public class Player implements IInventory, IHealthBar {
    
    private String name;
    private Armor[] armor;
    private int health;
    
    public Player(String name) {
        this.name = name;
        this.armor = new Armor[4];
        health = getMaxHealth();
    }
    
    public String getName() {
        return name;
    }
    
    @Override
    public int getHealth() {
        return health;
    }
    
     @Override
    public int getMaxHealth() {
        return 100;
    }   
    
    
    @Override
    public int getInventorySize() {
        return armor.length;
    }
    
    @Override
    public boolean setContent(int pos, Item item) {
        if (item instanceof Armor && ((Armor)item).getArmorType() == pos) {
            armor[pos] = (Armor)item;
            return true;
        }else{
            return false;
        }
    }
    
    
    @Override
    public Item getContent(int pos) {
        return armor[pos];
    }
    
    @Override
    public void takeDamage(int damage) {
        int armorValue = 0;
        for (int i = 0; i < armor.length; i++) {
            if (armor[i] != null) {
                armorValue += armor[i].getArmorValue();
            }
        }
        
        damage -= armorValue;
        if (damage > 0) {
            health -= damage;
        }
    }
    
    @Override
    public boolean isDead() {
        return health <= 0;
    }
    
}