package Units;

import World.Map;
import World.Location;

import Items.Item;
import java.util.ArrayList;

public class Player{
    
    private Map map;
    private int x;
    private int y;
    private int health;
    private ArrayList<Item> items;
    
    public Player(Map map, int x, int y) {
        warpTo(map, x, y);
        health = 10;
        items = new ArrayList<Item>();
    }
    
    
    public int getX() {
        return x;
    }
    
    public int getY() {
        return y;
    }
    
    public void printInMap() {
        map.printMap(this);
    }
    
    public void movePlayer(int offsetX, int offsetY) {
        Location moveTo = map.getLocationAtPosition(x + offsetX, y + offsetY);
    
        if (moveTo != null && !moveTo.isSolid()) {
            x += offsetX;
            y += offsetY;
            moveTo.onPlayerArrive(this);
        }else{
            System.out.println("You can't move there");
        }
    }
        
    public void decreaseHealth(int dmg) {
        health -= dmg;
        if (isDead()) {
            System.out.println("You died");
        }
    }
    
    public void heal(int val) {
        health += val;
    }
    
    public boolean isDead() {
        return health <= 0;
    }
    
    public int getHealth() {
        return health;
    }
    
    public void warpTo(Map map, int x, int y) {
        this.map = map;
        this.x = x;
        this.y = y;
    }
    
    public boolean pickUpItem(Item item) {
        items.add(item);
        return true;
    }
    
    public ArrayList<Item> getItems() {
        return items;
    }
    
}