package dragons;

import java.awt.Color;


public class EnemyDragon extends Dragon {
    
    public EnemyDragon(int x, int y, int health, int fire) { 
        super(x, y, health, fire);
        
        generateTarget();
    }
    
    public Color PrimaryColor() {
        if (getHealth() <= 0) {
            return new Color((int)(Math.random() * 255), 0, 0);
        }
        return new Color(255,0,0);
    }
    public Color SecondaryColor() {
        if (getHealth() <= 0) {
            return new Color((int)(Math.random() * 255), 0, 0);
        }
        return new Color(175,30,30);
    }
    public Color BorderColor() {
        if (getHealth() <= 0) {
            return new Color((int)(Math.random() * 255),0, 0);
        }
        return new Color(0,0,0);
    }
    
    
    private void generateTarget() {
        targetX = -500 + (int)(Math.random() * 2000);
        targetY = -250 + (int)(Math.random() * 500);
    }
    
    int targetX;
    int targetY;
    @Override
    public void update() {
        if (moveTowards(targetX,targetY)) {
            generateTarget();
        }
                
        super.update();        
    }
    
    //a very basic AI
    private boolean moveTowards(int x, int y) { 
        if (x < getX() && x < getX() - (float)Math.pow(Math.max(Math.abs(getSpeedX()),4),2) / (0.1F*2) ) {
            left = true;
            right = false;
        }else if(x > getX() && x > getX() + (float)Math.pow(Math.max(Math.abs(getSpeedX()),4),2) / (0.1F*2) ) {
            left = false;
            right = true;
        }else{
            left = false;
            right = false;
        }
        
        if (!getIsFlapping() && getYAtFlap() + getSpeedYAtFlap()*flapTime() >= y) {
            flying = true;
        }else{
            flying = false;
        }
        
        return Math.abs(x-getX()) <= 30 && Math.abs(y-getY()) <= 30;
    }
    
}
