package example.proxies;

import net.minecraftforge.client.MinecraftForgeClient;
import net.minecraftforge.client.model.AdvancedModelLoader;
import net.minecraftforge.client.model.IModelCustom;
import cpw.mods.fml.client.registry.ClientRegistry;
import cpw.mods.fml.client.registry.RenderingRegistry;
import example.blocks.BlockInfo;
import example.client.ModelDroid;
import example.client.RenderBomb;
import example.client.RenderBombBlock;
import example.client.RenderBombBlockItem;
import example.client.RenderDroid;
import example.client.RenderDroidItem;
import example.client.RenderMachine;
import example.client.RenderSpaceship;
import example.client.sounds.SoundHandler;
import example.entities.EntityBomb;
import example.entities.EntityDroid;
import example.entities.EntitySpaceship;
import example.items.ItemInfo;
import example.tileentities.TileEntityBomb;

public class ClientProxy extends CommonProxy {

	@Override
	public void initSounds() {
		new SoundHandler();
	}

	@Override
	public void initRenderers() {
		RenderingRegistry.registerEntityRenderingHandler(EntitySpaceship.class, new RenderSpaceship());
		
		ModelDroid model = new ModelDroid();
		RenderingRegistry.registerEntityRenderingHandler(EntityDroid.class, new RenderDroid(model));
		MinecraftForgeClient.registerItemRenderer(ItemInfo.DROID_ID + 256, new RenderDroidItem(model));
		
		RenderMachine machineRender = new RenderMachine();
		BlockInfo.MACHINE_RENDER_ID = machineRender.getRenderId();
		RenderingRegistry.registerBlockHandler(machineRender);
		
		RenderingRegistry.registerEntityRenderingHandler(EntityBomb.class, new RenderBomb());
		
		IModelCustom modelBomb = AdvancedModelLoader.loadModel("/assets/example/models/bomb.obj");
		ClientRegistry.bindTileEntitySpecialRenderer(TileEntityBomb.class, new RenderBombBlock(modelBomb));
		MinecraftForgeClient.registerItemRenderer(BlockInfo.BOMB_ID, new RenderBombBlockItem(modelBomb));
	}	
	
}
