package example.proxies;

import net.minecraftforge.client.MinecraftForgeClient;
import cpw.mods.fml.client.registry.RenderingRegistry;
import example.blocks.BlockInfo;
import example.client.ModelDroid;
import example.client.RenderDroid;
import example.client.RenderDroidItem;
import example.client.RenderMachine;
import example.client.RenderSpaceship;
import example.client.sounds.SoundHandler;
import example.entities.EntityDroid;
import example.entities.EntitySpaceship;
import example.items.ItemInfo;

public class ClientProxy extends CommonProxy {

	@Override
	public void initSounds() {
		new SoundHandler();
	}

	@Override
	public void initRenderers() {
		RenderingRegistry.registerEntityRenderingHandler(EntitySpaceship.class, new RenderSpaceship());
		
		ModelDroid model = new ModelDroid();
		RenderingRegistry.registerEntityRenderingHandler(EntityDroid.class, new RenderDroid(model));
		MinecraftForgeClient.registerItemRenderer(ItemInfo.DROID_ID + 256, new RenderDroidItem(model));
		
		RenderMachine machineRender = new RenderMachine();
		BlockInfo.MACHINE_RENDER_ID = machineRender.getRenderId();
		RenderingRegistry.registerBlockHandler(machineRender);
	}	
	
}
