package gui;

import java.awt.geom.Area;
import java.awt.geom.Arc2D;
import java.awt.Color;
import java.awt.Polygon;


public class HeartIcon extends Icon{
    public HeartIcon(IconHolder owner, int number) {
        super(owner, number);
    }
    
    
    @Override
    protected Area getArea() {
        Area heart = new Area();
        
        //create the two "bubbles" of the heart
        Arc2D leftBubble = new Arc2D.Float(x, y, 20, 20, 0, 270, Arc2D.CHORD);
        Arc2D rightBubble = new Arc2D.Float(x + 20, y, 20, 20, -90, 270, Arc2D.CHORD);
        
        //create the point of the heart
        Polygon bottom = new Polygon();
        bottom.addPoint(x + 1, y + 14);
        bottom.addPoint(x + 20, y + 6);
        bottom.addPoint(x + 38,y + 16);
        bottom.addPoint(x + 20,y + 34);
        
        //put the different parts of the heart together
        heart.add(new Area(leftBubble));
        heart.add(new Area(rightBubble));
        heart.add(new Area(bottom));
        
        return heart;
    }

    @Override
    protected Color getFilledColor() {
        return Color.red;
    }
    
        @Override 
    protected float getBorderLength(){
        return 120;
    }
    
}

