package inventory;

import java.awt.Graphics2D;
import java.awt.Font;
import java.awt.Color;
import java.awt.geom.Rectangle2D;
import java.awt.font.FontRenderContext;

import dragons.PlayerDragon;

public abstract class Item {
    
    protected String name;
    protected int amount;
    
    public Item(String name, int amount) {
        this.name = name;
        this.amount = amount;
    }
   
    
    public String getName() {
        return name;
    }
    
    public int getAmount() {
        return amount;
    }
    
    
    public void drawItem(Graphics2D g, int x, int y, boolean fullInfo) {
        drawIcon(g, x, y);
        
        g.setFont(new Font("Arial", Font.BOLD, 18) );
        
        String str = String.valueOf(amount);
        

        g.setColor(new Color(200, 0, 255)); 
        
         Rectangle2D rect = g.getFont().getStringBounds(str,new FontRenderContext(null,false,false));
         g.drawString(str, x + 30 - (int)rect.getWidth() + 5, y + 30);    
         
         if (fullInfo) {
             g.setFont(new Font("Arial", Font.BOLD, 20) );
             g.setColor(Color.white); 
             g.drawString(name, x + 40, y + 25);
         }
    }
    
    
    public abstract void useItem(PlayerDragon player);
    public abstract void drawIcon(Graphics2D g, int x, int y);
    
}