package inventory;

import java.awt.Graphics2D;

import java.awt.geom.Area;
import java.awt.geom.Arc2D;
import java.awt.Color;
import java.awt.Polygon;
import java.awt.geom.Ellipse2D;
import java.awt.Rectangle;
import java.awt.Stroke;
import java.awt.BasicStroke;

public abstract class Potion extends Item {
 
    public Potion(String name, int amount) {
        super(name, amount);
    }
    
    @Override
    public final void drawIcon(Graphics2D g, int x, int y) {
       Area potion = new Area();
        
       Stroke old = g.getStroke();
       
        potion.add(new Area(new Ellipse2D.Float(x + 4, y + 10, 22, 20)));    
        potion.add(new Area(new Rectangle(x + 9, y + 5, 12, 10)));
        potion.add(new Area(new Rectangle(x + 7, y, 16, 5)));

        
        Area filledPart = new Area(potion);
        filledPart.subtract(new Area(new Rectangle(x, y, 30, 7)));        

        //draw the gray background
        g.setColor(Color.gray);
        g.fill(potion);      

        g.setColor(getPotionColor());
        g.fill(filledPart); 
        
        g.setStroke(new BasicStroke(2));
        
        g.setColor(Color.black);
        g.draw(potion);  
        
        g.setStroke(old);
    }
    
    public abstract Color getPotionColor();
}