package world;

import java.awt.geom.Area;
import java.awt.Rectangle;
import java.awt.Graphics2D;
import java.util.EnumSet;

import main.Game;
import main.IGraphicalObject;
import main.RENDERPASS;


public abstract class Obstacle implements IGraphicalObject {
    
    //the position of this obstacle
    private float x;
    private float y;
    
    public float getX() {
        return x;
    }
    
    public float getY() {
        return y;
    }
    
    public void setX(float val) {
        x = val;
    }
    
    public void setY(float val) {
        y = val;
    }
    
    public Obstacle(float x, float y) {
        this.x = x;
        this.y = y;
        Game.instance.obstacles.add(this);
        Game.instance.objects.add(this);
    }
    
    
    //if this obstacle can be scorched by fire
    public boolean isFlamable() {
        return false;
    }
    
    //the collision box
    public abstract Area getArea();
    
    @Override
    public EnumSet<RENDERPASS> getRenderPass() {
        return EnumSet.of(RENDERPASS.BACKGROUND);
    }

    
    
}